/*
* Copyright (c) 2007 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Xhtmldef  declaration
*
*/



#ifndef XHTMLDEF_H
#define XHTMLDEF_H

#include <e32base.h>


//Structure - tags
_LIT(KHtmlTag,"html");
_LIT(KTitleTag, "title"); 

// Physical styles 
_LIT(KBrTag,"br");
// Headers
_LIT(KH1Tag,"h1");
_LIT(KH2Tag,"h2");
_LIT(KH3Tag,"h3");
_LIT(KH4Tag,"h4");
_LIT(KH5Tag,"h5");
_LIT(KH6Tag,"h6");
// Block 
_LIT(KBlockquoteTag, "blockquote");
_LIT(KAddressTag,"address");
_LIT(KDivTag,"div");
_LIT(KPTag,"p");
_LIT(KPreTag,"pre");
// Logical styles
_LIT(KStrongTag,"strong");
_LIT(KEmTag,"em");
_LIT(KCiteTag,"cite");
_LIT(KDfnTag,"dfn");
_LIT(KAbbrTag,"abbr");
_LIT(KAcronymTag,"acronym");
_LIT(KQTag,"q");
_LIT(KKbdTag,"kbd");
_LIT(KCodeTag,"code");
_LIT(KSampTag,"samp");
_LIT(KSpanTag,"span");
_LIT(KVarTag,"var");

// Presentation - tags
// Physical styles 
_LIT(KITag,"i");
_LIT(KBTag,"b");
_LIT(KBigTag,"big");	
_LIT(KHrTag,"hr");		
_LIT(KSmallTag,"small");		

_LIT(KImgTag, "img");

// List - tags
_LIT(KDdTag,"dd");			
_LIT(KDlTag,"dl");		
_LIT(KDtTag,"dt");		
_LIT(KUlTag,"ul");
_LIT(KOlTag,"ol");
_LIT(KLiTag,"li");

// Style Attribute - tags
// Attributes
_LIT(KColorAttr,"color");
_LIT(KCenterAttr,"center");
_LIT(KJustifyAttr,"justify");
_LIT(KTextAlignAttr, "text-align");
_LIT(KStyleAttr,"style");  
_LIT(KTextDecorationAttr,"text-decoration");  
_LIT(KUnderlineAttr,"underline");  
_LIT(KFontTag,"font");


#endif
